package cn.com.infosec.mobile.android.framework.crypto.impl.gm;

import cn.com.infosec.math.ec.ECPoint;
import cn.com.infosec.util.BigIntegers;
import java.io.PrintStream;
import java.math.BigInteger;
import java.security.SecureRandom;

public class SM2KeyExchange {
   private static final int SM2_SIZE = 32;
   private static final BigInteger w2 = new BigInteger("80000000000000000000000000000000", 16);
   private static final BigInteger h;
   private static final ECPoint gmg;
   private static final BigInteger gmn;
   private static int nBitLength;
   private static SecureRandom random;

   public static SecureRandom getSecureRandom() {
      SecureRandom var10000;
      SecureRandom var0;
      try {
         var10000 = SecureRandom.getInstance("SHA1PRNG");
      } catch (Exception var1) {
         var0 = new SecureRandom.<init>();
         return var0;
      }

      var0 = var10000;
      return var0;
   }

   public static void genKeyPair(ECPoint kg, BigInteger k) {
      BigInteger kg1;
      while((kg1 = (new BigInteger(nBitLength, random)).mod(gmn)).compareTo(BigInteger.ZERO) <= 0) {
      }

      gmg.multiply(kg1);
   }

   public static void genKeyPair(byte[] rabi, byte[] ra) {
      BigInteger var2;
      while((var2 = (new BigInteger(nBitLength, random)).mod(gmn)).compareTo(BigInteger.ZERO) <= 0) {
      }

      BigInteger var10000 = var2;
      ECPoint var3 = gmg.multiply(var2);
      byte[] var10001 = BigIntegers.asUnsignedByteArray(var10000);
      ECPoint var5 = var3;
      int var4 = var10001.length;
      System.arraycopy(var10001, 0, rabi, 0, var4);
      System.arraycopy(SM2Util.point2octect(var5), 0, ra, 0, 65);
   }

   public static byte[] genSessionKeyClient(byte[] ra, byte[] pka, byte[] rb, byte[] pkb, byte[] rba, byte[] dba, byte[] ida, byte[] idb, int klen) {
      byte[] var10001 = rb;
      rb = new byte[32];
      byte[] var9 = new byte[32];
      System.arraycopy(var10001, 1, rb, 0, 32);
      BigInteger var10;
      var10 = new BigInteger.<init>(1, rb);
      BigInteger var11;
      BigInteger var18 = var11 = w2;
      byte[] var10002 = ra;
      BigInteger ra1;
      var10 = var11.add(var10.and(var11.add((ra1 = BigInteger.ONE).negate())));
      BigInteger rba1 = (new BigInteger(1, dba)).add(var10.multiply(new BigInteger(1, rba))).mod(gmn).multiply(h);
      ECPoint dba1;
      ra1 = var18.add((dba1 = SM2Util.octect2point(var10002)).getX().toBigInteger().and(var11.add(ra1.negate())));
      ECPoint ra2;
      if ((ra2 = SM2Util.octect2point(pka).multiply(rba1).add(dba1.multiply(ra1.multiply(rba1)))).isInfinity()) {
         return null;
      } else {
         pka = SM2Util.getZA(ida, pka);
         var10001 = pkb = SM2Util.getZA(idb, pkb);
         byte[] var10003 = pka;
         byte[] var10004 = pka;
         ECPoint var10008 = ra2;
         ra = new byte[pka.length + 64 + pkb.length];
         SM2Util.point2octect(var10008, rb, var9);
         System.arraycopy(rb, 0, ra, 0, 32);
         System.arraycopy(var9, 0, ra, 32, 32);
         int pka1 = pka.length;
         System.arraycopy(var10004, 0, ra, 64, pka1);
         pka1 = var10003.length + 64;
         int rb1 = var10001.length;
         System.arraycopy(var10001, 0, ra, pka1, rb1);
         byte[] var10000 = pka = new byte[klen];
         System.arraycopy(SM2Util.kdf(ra, klen), 0, pka, 0, klen);
         return var10000;
      }
   }

   public static byte[] genSessionKeyServer(byte[] rabi, byte[] ra, byte[] daa, byte[] rb, byte[] pka, byte[] pkb, byte[] ida, byte[] idb, int klen) {
      byte[] var10000 = rb;
      ECPoint ra1 = SM2Util.octect2point(ra);
      BigInteger ra2;
      BigInteger rb1;
      BigInteger rabi1 = (rb1 = w2).add(ra1.getX().toBigInteger().and(rb1.add((ra2 = BigInteger.ONE).negate()))).multiply(new BigInteger(1, rabi)).add(new BigInteger(1, daa)).mod(gmn).multiply(h);
      ECPoint daa1;
      if ((daa1 = SM2Util.octect2point(var10000)) == null) {
         return null;
      } else {
         ECPoint var17 = daa1;
         ra2 = rb1.add(daa1.getX().toBigInteger().and(rb1.add(ra2.negate())));
         daa1 = SM2Util.octect2point(pkb);
         ECPoint rabi2;
         if ((rabi2 = var17.multiply(rabi1.multiply(ra2)).add(daa1.multiply(rabi1))).isInfinity()) {
            return null;
         } else {
            SM2Util.point2octect(rabi2, rabi = new byte[32], ra = new byte[32]);
            daa = SM2Util.getZA(ida, pka);
            byte[] var10001 = rb = SM2Util.getZA(idb, pkb);
            byte[] var10007 = rabi;
            rabi = new byte[daa.length + 64 + rb.length];
            System.arraycopy(var10007, 0, rabi, 0, 32);
            System.arraycopy(ra, 0, rabi, 32, 32);
            int ra3 = daa.length;
            System.arraycopy(daa, 0, rabi, 64, ra3);
            ra3 = daa.length + 64;
            int daa2 = var10001.length;
            System.arraycopy(var10001, 0, rabi, ra3, daa2);
            var10000 = ra = new byte[klen];
            System.arraycopy(SM2Util.kdf(rabi, klen), 0, ra, 0, klen);
            return var10000;
         }
      }
   }

   public static void main(String[] args) {
      byte[] args1 = new byte[32];
      byte[] var1;
      byte[] var10000 = var1 = new byte[32];
      byte[] var2 = new byte[65];
      byte[] var3 = new byte[65];
      genKeyPair(args1, var2);
      genKeyPair(var10000, var3);
      byte[] var4;
      var10000 = var4 = new byte[32];
      byte[] var5;
      byte[] var10001 = var5 = new byte[65];
      genKeyPair(var4, var5);
      byte[] var6;
      genKeyPair(var4 = new byte[32], var6 = new byte[65]);
      byte[] var7 = "ALICE123@YAHOO.COM".getBytes();
      byte[] var8 = "BILL456@YAHOO.COM".getBytes();
      short var9 = 128;
      var1 = genSessionKeyClient(var10001, var2, var6, var3, var4, var1, var7, var8, 128);
      args1 = genSessionKeyServer(var10000, var5, args1, var6, var2, var3, var7, var8, 128);

      for(int var11 = 0; var11 < var9; ++var11) {
         PrintStream var13 = System.out;
         StringBuilder var14 = new StringBuilder();
         Object[] var12;
         (var12 = new Object[1])[0] = var1[var11];
         var14 = var14.append(String.format("%02X", var12)).append("=");
         (var12 = new Object[1])[0] = args1[var11];
         var13.println(var14.append(String.format("%02X", var12)).toString());
      }

   }

   static {
      h = BigInteger.ONE;
      gmg = SM2GMParameter.gmg;
      nBitLength = (gmn = SM2GMParameter.gmn).bitLength();
      random = getSecureRandom();
   }
}
